/* $Id: keyboardconfig.hpp,v 1.7.4.2 2006/01/24 10:08:10 chfreund Exp $ */

#ifndef _KEYBOARDCONFIG_HPP_
#define _KEYBOARDCONFIG_HPP_

#include <SDL.h>

class WopSettings;

class KeyboardConfig {
public:
	enum KeyID {
		LEFT = 0,
		RIGHT,
		DOWN,
		UP,
		SHOOT,
		JUMP,
		DIG,
		JET,
		ROPE_ON,
		ROPE_OFF,
		ROPE_IN,
		ROPE_OUT,
		ROPE_REL,
		SCREENSHOT,
		DEBUG,
		DEC_VOL,
		INC_VOL,
		TOGGLE_JUKEBOX,
		WEAPON1,
		WEAPON2,
		WEAPON3,
		WEAPON4,
		WEAPON5,
		WEAPON6,
		WEAPON7,
		WEAPON8,
		WEAPON9,
		WEAPON0,
		SPAWN,
		NEXT_WEAPON,
		PREV_WEAPON,
		INSERT_REPLAY_BOOKMARK,
		CHANGE_FOCUS,
		TOGGLE_FULLSCREEN,
		SHOW_FPS,
		LIMIT_FPS,
		LAST_KEY_ID
	};
	static const char* keyName[];
	SDLKey key[LAST_KEY_ID];

public:
	KeyboardConfig();
	void readSettings( WopSettings* settings );
	void writeSettings( WopSettings* settings ) const;

private:
	void readSetting( WopSettings* settings, const char* settingName, SDLKey& keyValue );
	void writeSetting( WopSettings* settings, const char* settingName,
	                   SDLKey keyValue ) const;
};

#endif // _KEYBOARDCONFIG_HPP_
