#include "messages.hpp"
#include <sstream>
#include "random.hpp"

std::string MessageGenerator::createFragMessage( const char* killer, const char* victim ) {
	std::ostringstream os;
	Uint32 messageType = localRnd.getUint32Between( 0, 10 );
	switch ( messageType ) {
	case 0:
		os << killer << " killed " << victim;
		break;
	case 1:
		os << killer << " fragged " << victim;
		break;
	case 2:
		os << killer << " pulverized " << victim;
		break;
	case 3:
		os << killer << " blew " << victim << " to smithereens";
		break;
	case 4:
		os << killer << " shredded " << victim;
		break;
	case 5:
		os << killer << " disposed " << victim;
		break;
	case 6:
		os << killer << " nuked " << victim;
		break;
	case 7:
		os << killer << " fried " << victim;
		break;
	case 8:
		os << killer << " set up " << victim << " the bomb";
		break;
	case 9:
		os << killer << " zapped " << victim;
		break;
	case 10:
	default:
		os << killer << " disintegrated " << victim;
		break;
	}
	return os.str();
}

std::string MessageGenerator::createSuicideMessage( const char* killer ) {
	std::ostringstream os;
	Uint32 messageType = localRnd.getUint32Between( 0, 13 );
	switch ( messageType ) {
	case 0:
		os << killer << " commited suicide";
		break;
	case 1:
		os << killer << " was tired of life";
		break;
	case 2:
		os << killer << " decided to start over";
		break;
	case 3:
		os << killer << " made a stupid mistake";
		break;
	case 4:
		os << killer << " went to hell";
		break;
	case 5:
		os << killer << " kicked the bucket";
		break;
	case 6:
		os << killer << " did a hard reset";
		break;
	case 7:
		os << killer << " was K.I.A.";
		break;
	case 8:
		os << killer << " sleeps with the fishes";
		break;
	case 9:
		os << killer << " wanted to rest in pieces";
		break;
	case 10:
		os << killer << " is pushing up the daisies";
		break;
	case 11:
		os << killer << " lost his hull integrity";
		break;
	case 12:
		os << killer << " proved Darwin's Theory of Wormolution";
		break;
	case 13:
	default:
		os << killer << " popped his cogs";
		break;
	}
	return os.str();
}

std::string MessageGenerator::createGoalMessage( const char* scorer ) {
	std::ostringstream os;
	Uint32 messageType = localRnd.getUint32Between( 0, 5 );
	switch ( messageType ) {
	case 0:
		os << scorer << " scored a goal";
		break;
	case 1:
		os << scorer << " schiesst... Tor! Tor! Tor! Tor! Tor!";
		break;
	case 2:
		os << scorer << " placed the ball perfectly";
		break;
	case 3:
		os << "One goal for " << scorer;
		break;
	case 4:
		os << "All other players were too stupid to prevent " << scorer << " from making a goal";
		break;
	case 5:
	default:
		os << "nGoals[" << scorer << "]++;";
		break;
	}
	return os.str();
}

