/* $Id: objectpaths.hpp,v 1.2 2005/06/28 13:55:21 chfreund Exp $ */

#include "settings.hpp"
#include "constants.hpp"

/**********************************************************/

//! loadable paths with an object ID as key
class ObjectPaths : protected SettingDataBase
{
	public:

		ObjectPaths();
		~ObjectPaths();

		//! \name loading and access
		//@{
		//! load paths from \c <basePath>/<file> in section \c section
		bool load( const char* const basePath,
		           const char* const file,
		           const char* const section = NULL );
		//! bypass to SettingDataBase::getSetting
		Setting* getSetting( const char *const IDString ) const {
			return SettingDataBase::getSetting( IDString );
		}
		//@}

	protected:

		//! initializes the static definitions
		void initSettingDefs();

		//! definitions
		static SettingDef m_SettingDef[NUMBER_OF_OBJECT_IDs+1];
};

/**********************************************************/
