/* $Id: weaponhomingmissile.hpp,v 1.5 2005/06/28 13:55:25 chfreund Exp $ */

#ifndef _WEAPONHOMINGMISSILE_HPP_
#define _WEAPONHOMINGMISSILE_HPP_

/**********************************************************/

#include "weapon.hpp"
#include "homingmissile.hpp"
#include "audio.hpp"

/**********************************************************/

class WeaponHomingMissile : public Weapon
{
	public:
	
		WeaponHomingMissile() {
			m_ID          = WEAPON_HOMING_MISSILE;
			m_maximumAmmo =   1;
			m_reloadTime  =  15;
			m_chargeTime  = 100;
			rechargeNow();
			// load sample for fire action
			m_shotSample = Audio::getInstance()
			    ->loadSound( "sound/weapons/missile/launch.wav" );
			// load sample for explosion
			HomingMissile::m_explodeSample = Audio::getInstance()
			    ->loadSound( "sound/effects/explosion1.wav" );
			// load sample for this cool "pling, pling" :)
			HomingMissile::m_damageSample = Audio::getInstance()
			    ->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar,
		                          const StationaryGun* gun = NULL ) const;
};

/**********************************************************/

#endif // _WEAPONHOMINGMISSILE_HPP_
